class Easeprobe < Formula
  desc "Simple, standalone, and lightWeight tool that can do health/status checking"
  homepage "https://github.com/megaease/easeprobe"
  url "https://github.com/megaease/easeprobe/archive/refs/tags/v2.1.2.tar.gz"
  sha256 "e5372b2a29aa46d527b38aec39ea4cc9fc3f4b35712f9d5dff532924bfbc0db7"
  license "Apache-2.0"
  head "https://github.com/megaease/easeprobe.git", branch: "main"

  depends_on "go" => :build

  # build patch to support go1.21 build
  # upstream pr ref, https://github.com/megaease/easeprobe/pull/471
  patch do
    url "https://github.com/megaease/easeprobe/commit/54a3a9aca42510ad2032f624ba9dff7e17b47e54.patch?full_index=1"
    sha256 "aeac6dfe643556d763b2d206c958385482c62fef3d1556d704bc93a52ea8ddbf"
  end

  def install
    ldflags = %W[
      -s -w
      -X github.com/megaease/easeprobe/pkg/version.RELEASE=#{version}
      -X github.com/megaease/easeprobe/pkg/version.COMMIT=#{tap.user}
      -X github.com/megaease/easeprobe/pkg/version.REPO=megaease/easeprobe
    ]
    system "go", "build", *std_go_args(ldflags: ldflags), "./cmd/easeprobe"
  end

  test do
    (testpath/"config.yml").write <<~EOS.chomp
      http:
        - name: "brew.sh"
          url: "https://brew.sh"
      notify:
        log:
          - name: "logfile"
            file: #{testpath}/easeprobe.log
    EOS

    easeprobe_stdout = (testpath/"easeprobe.log")

    pid = fork do
      $stdout.reopen(easeprobe_stdout)
      exec bin/"easeprobe", "-f", testpath/"config.yml"
    end
    sleep 2
    assert_match "Ready to monitor(http): brew.sh", easeprobe_stdout.read
  ensure
    Process.kill("TERM", pid)
    Process.wait(pid)
  end
end
